function [SubImageIndex, Offset] = GetSubImageIndex ( SubarrayIdx, ExpandWidth, s )
  xmin = SubarrayIdx{1}(1) - ExpandWidth;
  xmax = SubarrayIdx{1}(end) + ExpandWidth;
  if xmin < 1
    xmin = 1;
  end
  if xmax > s(1)
    xmax = s(1);
  end
  xind = xmin:xmax;
  
  ymin = SubarrayIdx{2}(1) - ExpandWidth;
  ymax = SubarrayIdx{2}(end) + ExpandWidth;
  if ymin < 1
    ymin = 1;
  end
  if ymax > s(2)
    ymax = s(2);
  end
  yind = ymin:ymax;
  
  zmin = SubarrayIdx{3}(1) - ExpandWidth;
  zmax = SubarrayIdx{3}(end) + ExpandWidth;
  if zmin < 1
    zmin = 1;
  end
  if zmax > s(3)
    zmax = s(3);
  end
  zind = zmin:zmax;
  
  Offset = [xmin ymin zmin];
  SubImageIndex = {xind, yind, zind};
