function DumpSpheres ( Properties, varargin )
  
WriteToFile = 0;
if nargin >= 2
  fid = varargin{1};
  WriteToFile = 1;
end
  
s = sprintf ( 'Id\tMatch\tVoxels\tVolume\tx\ty\tz\tR\tA\tS\tPCAVariance' );

if WriteToFile
  fprintf ( fid, s );
  fprintf ( fid, '\n' );
else
  disp ( s );
end


for i = 1:length(Properties),
  s = sprintf ( '%d\t%d\t%d\t%0.4f\t%0.3f\t%0.3f\t%0.3f\t%0.3f\t%0.3f\t%0.3f\t%0.3f', ...
                i, ...
                Properties(i).Match, ...
                Properties(i).Voxels, ...
                Properties(i).Volume, ...
                Properties(i).COM(1), ...
                Properties(i).COM(2), ...
                Properties(i).COM(3), ...
                Properties(i).ScannerCOM(1), ...
                Properties(i).ScannerCOM(2), ...
                Properties(i).ScannerCOM(3), ...
                Properties(i).PCAVariance );
  if WriteToFile
    fprintf ( fid, s );
    fprintf ( fid, '\n' );
  else
    disp ( s );
  end
end
                   
                   
  