function fid = SafeFOpen ( Name, option )
% Throw an error if we try to overwrite

  foo = fopen ( Name, 'r' );
  
  if foo ~= -1
    fclose ( foo );
    error ( sprintf ( 'File: %s already exists!', Name ) );
  end
  
  fid = fopen ( Name, option );
  return